#ifndef EFL_TEXT_EO_HH
#define EFL_TEXT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Text;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text> : ::std::true_type {}; } }
namespace efl { 
struct Text;
} 

namespace eo_cxx {
namespace efl { 
struct Text {
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type text_get() const;
   ::efl::eolian::return_traits<void>::type text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Text() const;
   operator ::efl::Text&();
   operator ::efl::Text const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Text : ::efl::eo::concrete
{
   explicit Text( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Text(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Text(Text const& other) = default;
   Text(Text&& other) = default;
   Text& operator=(Text const& other) = default;
   Text& operator=(Text&& other) = default;
   Text()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Text( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Text(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type text_get() const;
   ::efl::eolian::return_traits<void>::type text_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Text) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text>::value, "");
} 
#endif
